unit MainForm;

interface

uses
  Forms, Windows, Classes, StdCtrls, SysUtils, ComCtrls,
  ShellAPI, Controls, Spin, Messages, MMsystem, Graphics;

type
  TGameForm = class(TForm)
    MoneyBox: TGroupBox;
    PlayerData: TGroupBox;
    Name: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;                      
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    MoneyMax: TButton;
    MoneyDefault: TButton;
    PlayerDefault: TButton;
    PlusScore: TButton;
    PlusHappy: TButton;
    MinusScore: TButton;
    MinusHappy: TButton;
    HelpBTN: TButton;
    CalcBTN: TButton;
    notepadBTN: TButton;
    PlusGoverment: TButton;
    MinusGoverment: TButton;
    TimeMin: TButton;
    TimeMax: TButton;
    mspaintBTN: TButton;
    ieBTN: TButton;
    Money: TSpinEdit;
    BankPercent: TSpinEdit;
    BankMoney: TSpinEdit;
    Score: TSpinEdit;
    Happy: TSpinEdit;
    TimeSpeed: TSpinEdit;
    MoneyGet: TSpinEdit;
    Goverment: TSpinEdit;
    PlayerYears: TSpinEdit;
    TimeYear: TSpinEdit;
    TimeMonth: TSpinEdit;
    TimeData: TSpinEdit;

    procedure MoneyDefaultClick(Sender: TObject);
    procedure MoneyMaxClick(Sender: TObject);
    procedure PlayerDefaultClick(Sender: TObject);
    procedure PlusScoreClick(Sender: TObject);
    procedure PlusHappyClick(Sender: TObject);
    procedure MinusScoreClick(Sender: TObject);
    procedure MinusHappyClick(Sender: TObject);
    procedure HelpBTNClick(Sender: TObject);
    procedure CalcBTNClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure notepadBTNClick(Sender: TObject);
    procedure PlusGovermentClick(Sender: TObject);
    procedure MinusGovermentCick(Sender: TObject);
    procedure TimeMinClick(Sender: TObject);
    procedure TimeMaxClick(Sender: TObject);
    procedure TimeSpeedChange(Sender: TObject);
    procedure mspaintBTNClick(Sender: TObject);
    procedure PlayerYearsChange(Sender: TObject);
    procedure ieBTNClick(Sender: TObject);
    procedure NameChange(Sender: TObject);
    procedure MoneyGetChange(Sender: TObject);
    procedure MoneyChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    procedure MyShowHint(var HintStr: string; var CanShow: Boolean;var HintInfo: THintInfo);
    { Public declarations }
  end;


const GameInfoSTR : PChar = ',         .';
const GameVersion : PChar = '3.5.5';
const PluginVersion : PChar = '1.1.3';
var
  GameForm : TGameForm;
  MoneyDEF, BankMoneyDEF, BankPercentDEF, ScoreDEF,
  HappyDEF, TimeSpeedDEF, MoneyGetDEF, GovermentDEF,
  PlayerYearsDEF, TimeDataDEF, TimeMonthDEF,
  TimeYearDEF : Longint;
  NameDEF : String;
  CalcPath, NotepadPath, msPaintPath, IEPath : String;
  CurGameVersion : String;
  WND, SystemDisk : String;

implementation

{$R *.dfm}

//  wav
(*
function PlayWave(name : string) : boolean;
var
  FindHandle, ResHandle : THandle;
  ResPtr : Pointer;
  result_ : boolean;
begin
  result_ := true;
  FindHandle := FindResource(HInstance, PChar(name), RT_RCDATA);
  if FindHandle <> 0 then
  begin
    ResHandle := LoadResource(HInstance, FindHandle);
    if ResHandle <> 0 then
    begin
      ResPtr := LockResource(ResHandle);
      if ResPtr <> nil then
        SndPlaySound(PChar(ResPtr), snd_ASync or snd_Memory)
      else result_ := false;
      UnlockResource(ResHandle);
    end;
    FreeResource(FindHandle);
  end else result_ := false;

  PlayWave := result_;
end;
*)

//        .
function CheckFileExist(name : ANSIString) : boolean;
var ex : boolean;
    f : file;
begin
  ex := false;
{$I-}
  AssignFile(f, name);
  ReSet(f, 1);
{$I+}
  if IOresult = 0 then
  begin
    ex := true;
    CloseFile(f);
  end;
  CheckFileExist := ex;
end;

//  .
procedure Run(name : ANSIString);
//var msg_str : string;
begin
  ShellExecute(GameForm.Handle, 'open', PChar(name), nil, nil, SW_SHOWNORMAL)
{
  if CheckFileExist(name) then
    ShellExecute(GameForm.WindowHandle, nil, PChar(name), nil, nil, SW_SHOW)
  else begin
         msg_str := ' "' + name + '"     !';
         MessageBox(GameForm.WindowHandle, @msg_str[1], '!', MB_OK or MB_ICONERROR);
       end;
}
end;

//     Windows
function WhereWindowsInstalled : string;
var  WinDir  : string;
     WinDirP : PChar;
begin
  GetMem(WinDirP, MAX_PATH);
  if GetWindowsDirectory(WinDirP, MAX_PATH) > 0 then
    WinDir := StrPas(WinDirP);
  FreeMem(WinDirP, MAX_PATH);
  WhereWindowsInstalled := WinDir;
end;

procedure TGameForm.MyShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
var
  i: integer;
begin
  for i := 0 to Application.ComponentCount - 1 do
  begin
    if Application.Components[i] is THintWindow then
    begin
      with THintWindow(Application.Components[i]).Canvas do
      begin
        Font.Name := 'MS Sans Serif';
        Font.Size := 8;
        Font.Style := [{fsBold}];
        HintInfo.HintColor := clGreen;
      end;
    end;
  end;
end;

procedure TGameForm.FormCreate(Sender: TObject);
var
   history_file : TextFile;
begin
  GameForm.ScreenSnap := true;
  Application.OnShowHint := MyShowHint;
//  PlayWave('LOAD_GAMEHACK');
  SendMessage(GameForm.Handle, WM_SETICON, 1, LoadIcon(hInstance, 'MAINICON'));

  WND := WhereWindowsInstalled;
  SystemDisk := WND[1] + WND[2] + WND[3];

  if CheckFileExist(WND+'\Media\notify.wav') = true then
  sndPlaySound(PChar(WND+'\Media\notify.wav'), SND_ASYNC);

  CalcPath := WND + '\system32\calc.exe';
  if CheckFileExist(CalcPath) = false then CalcPath := WND + '\calc.exe';
  if CheckFileExist(CalcPath) = false then GameForm.CalcBTN.Enabled := false;

  NotepadPath := WND + '\system32\notepad.exe';
  if CheckFileExist(NotepadPath) = false then NotepadPath := WND + '\notepad.exe';
  if CheckFileExist(NotepadPath) = false then GameForm.notepadBTN.Enabled := false;

  msPaintPath := WND + '\system32\mspaint.exe';
  if CheckFileExist(msPaintPath) = false then msPaintPath := WND + '\mspaint.exe';
  if CheckFileExist(msPaintPath) = false then GameForm.mspaintBTN.Enabled := false;

  IEPath := SystemDisk + 'Program Files\Internet Explorer\iexplore.exe';
  if CheckFileExist(IEPath) = false then GameForm.ieBTN.Enabled := false;

  if GameForm.TimeSpeed.Value = 24 then GameForm.TimeSpeed.ShowHint := True
  else GameForm.TimeSpeed.ShowHint := False;

  if GameForm.PlayerYears.Value <= 10 then GameForm.PlayerYears.ShowHint := True
  else GameForm.PlayerYears.ShowHint := False;

  CurGameVersion := '';
  if CheckFileExist('..\History.txt') = true then
  begin
    AssignFile(history_file, '..\History.txt');
    ReSet(history_file);
    Read(history_file, CurGameVersion);
    CurGameVersion[1] := '';
    CloseFile(history_file);
  end;

  GameForm.MoneyGet.Hint := '-       ?'+#13+'- ,  ,   .';
  GameForm.Money.Hint := ',  !';
  GameForm.MoneyGet.OnChange(GameForm.MoneyGet);

//  AlphaBlend := True;
//  AlphaBlendValue := 255;
end;

procedure TGameForm.MoneyDefaultClick(Sender: TObject);
begin
  if CheckFileExist(WND+'\Media\chimes.wav') = true then
  sndPlaySound(PChar(WND+'\Media\chimes.wav'), SND_ASYNC);

  Money.Value       := MoneyDEF;
  BankMoney.Value   := BankMoneyDEF;
  BankPercent.Value := BankPercentDEF;
  MoneyGet.Value    := MoneyGetDEF;
end;

procedure TGameForm.MoneyMaxClick(Sender: TObject);
begin
  if CheckFileExist(WND+'\Media\ding.wav') = true then
  sndPlaySound(PChar(WND+'\Media\ding.wav'), SND_ASYNC);

  Money.Value       := Money.MaxValue;
  BankMoney.Value   := BankMoney.MaxValue;
  BankPercent.Value := BankPercent.MaxValue;
  MoneyGet.Value    := MoneyGet.MaxValue;
end;

procedure TGameForm.PlayerDefaultClick(Sender: TObject);
begin
  if CheckFileExist(WND+'\Media\chimes.wav') = true then
  sndPlaySound(PChar(WND+'\Media\chimes.wav'), SND_ASYNC);

  GameForm.Name.Text         := NameDEF;
  GameForm.Score.Value       := ScoreDEF;
  GameForm.Happy.Value       := HappyDEF;
  GameForm.TimeSpeed.Value   := TimeSpeedDEF;
  GameForm.Goverment.Value   := GovermentDEF;
  GameForm.PlayerYears.Value := PlayerYearsDEF;
  GameForm.TimeData.Value    := TimeDataDEF;
  GameForm.TimeMonth.Value   := TimeMonthDEF;
  GameForm.TimeYear.Value    := TimeYearDEF;
end;

procedure TGameForm.PlusScoreClick(Sender: TObject);
begin
  GameForm.Score.Value := GameForm.Score.Value + 100;
  if GameForm.Score.Value > GameForm.Score.MaxValue then GameForm.Score.Value := GameForm.Score.MaxValue;
end;

procedure TGameForm.PlusHappyClick(Sender: TObject);
begin
  GameForm.Happy.Value := GameForm.Happy.Value + 10;
  if GameForm.Happy.Value > GameForm.Happy.MaxValue then GameForm.Happy.Value := GameForm.Happy.MaxValue;
end;

procedure TGameForm.MinusScoreClick(Sender: TObject);
begin
  GameForm.Score.Value := GameForm.Score.Value - 100;
  if GameForm.Score.Value < 0 then GameForm.Score.Value := 0;
end;

procedure TGameForm.MinusHappyClick(Sender: TObject);
begin
  GameForm.Happy.Value := GameForm.Happy.Value - 10;
  if GameForm.Happy.Value < 0 then GameForm.Happy.Value := 0;
end;

procedure TGameForm.PlusGovermentClick(Sender: TObject);
begin
  GameForm.Goverment.Value := GameForm.Goverment.Value + 10;
  if GameForm.Goverment.Value > GameForm.Goverment.MaxValue then GameForm.Goverment.Value := GameForm.Goverment.MaxValue;
end;

procedure TGameForm.MinusGovermentCick(Sender: TObject);
begin
  GameForm.Goverment.Value := GameForm.Goverment.Value - 10;
  if GameForm.Goverment.Value < 0 then GameForm.Goverment.Value := 0;
end;

procedure TGameForm.HelpBTNClick(Sender: TObject);
var msg : string;
begin
  msg := ': haM3r'+#13+
         'E-mail: bvlad36@bk.ru'+#13+
         ' : '+PluginVersion+#13+
         ' CE3: rpprogs.narod.ru'+#13+#13+
         GameInfoSTR+
         '   ,          e-mail.'+#13+#13+
         '   CompEvo  '+GameVersion;
  if length(CurGameVersion) > 0 then
    msg := msg+#13+' '+CurGameVersion;
  MessageBox(GameForm.WindowHandle, @msg[1], 'GameHack Info', MB_OK or mb_iconinformation);
end;

procedure TGameForm.CalcBTNClick(Sender: TObject);
begin
  if CheckFileExist(WND+'\Media\start.wav') = true then
    sndPlaySound(PChar(WND+'\Media\start.wav'), SND_ASYNC);
  Run(CalcPath);
end;

procedure TGameForm.notepadBTNClick(Sender: TObject);
begin
  if CheckFileExist(WND+'\Media\start.wav') = true then
    sndPlaySound(PChar(WND+'\Media\start.wav'), SND_ASYNC);
  Run(NotepadPath);
end;

procedure TGameForm.mspaintBTNClick(Sender: TObject);
begin
  if CheckFileExist(WND+'\Media\start.wav') = true then
    sndPlaySound(PChar(WND+'\Media\start.wav'), SND_ASYNC);
  Run(msPaintPath);
end;

procedure TGameForm.ieBTNClick(Sender: TObject);
begin
  if CheckFileExist(WND+'\Media\start.wav') = true then
    sndPlaySound(PChar(WND+'\Media\start.wav'), SND_ASYNC);
//  Run(iePath);
  ShellExecute(GameForm.Handle, 'open', 'http://rpprogs.narod.ru', nil, nil, SW_SHOWNORMAL)
end;

procedure TGameForm.TimeMinClick(Sender: TObject);
begin
  GameForm.TimeSpeed.Value := 1;
end;

procedure TGameForm.TimeMaxClick(Sender: TObject);
begin
  GameForm.TimeSpeed.Value := 24;
end;

procedure TGameForm.TimeSpeedChange(Sender: TObject);
begin
  if GameForm.TimeSpeed.Value = 24 then GameForm.TimeSpeed.ShowHint := True
  else GameForm.TimeSpeed.ShowHint := False;
end;

procedure TGameForm.PlayerYearsChange(Sender: TObject);
begin
  if GameForm.PlayerYears.Value <= 10 then GameForm.PlayerYears.ShowHint := True
  else GameForm.PlayerYears.ShowHint := False;
end;

procedure TGameForm.NameChange(Sender: TObject);
begin
  GameForm.Name.ShowHint := true;

  if strlower(PChar(GameForm.Name.Text)) = 'ham3r' then
    GameForm.Name.Hint := 'e-mail: bvlad36@bk.ru'

  else if strlower(PChar(GameForm.Name.Text)) = 'flym' then
    GameForm.Name.Hint := 'e-mail: flym2005@gmail.com'

  else if GameForm.Name.Text = ' ' then
    GameForm.Name.Hint := 'e-mail: sardor90@gmail.com'

  else if GameForm.Name.Text = ' ' then
    GameForm.Name.Hint := 'e-mail: sardor90@gmail.com'

  else if GameForm.Name.Text = ' ' then
    GameForm.Name.Hint := 'e-mail: RPsoft@mail.ru'

  else GameForm.Name.ShowHint := false;
end;

procedure TGameForm.MoneyGetChange(Sender: TObject);
begin
  if GameForm.MoneyGet.Value = 0 then GameForm.MoneyGet.ShowHint := true
  else GameForm.MoneyGet.ShowHint := false;
end;

procedure TGameForm.MoneyChange(Sender: TObject);
begin
  if GameForm.Money.Value = 0 then GameForm.Money.ShowHint := true
  else GameForm.Money.ShowHint := false;
end;

procedure TGameForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if CheckFileExist(WND+'\Media\start.wav') = true then
    sndPlaySound(PChar(WND+'\Media\start.wav'), SND_ASYNC);
end;

end.







